import * as i0 from '@angular/core';
import { Injectable, Component, Input, NgModule } from '@angular/core';
import * as i1 from '@angular/forms';
import { NG_VALUE_ACCESSOR, FormsModule, ReactiveFormsModule } from '@angular/forms';

class FormControlsService {
    constructor() { }
}
FormControlsService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormControlsService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
FormControlsService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormControlsService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormControlsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class FormControlsComponent {
    constructor() { }
    ngOnInit() {
    }
}
FormControlsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormControlsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
FormControlsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.3", type: FormControlsComponent, selector: "lib-form-controls", ngImport: i0, template: `
    <p>
      form-controls works!
    </p>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormControlsComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-form-controls',
                    template: `
    <p>
      form-controls works!
    </p>
  `,
                    styles: []
                }]
        }], ctorParameters: function () { return []; } });

class FormInputComponent {
    constructor() { }
    writeValue(obj) {
        this.value = obj;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    ngOnInit() {
    }
}
FormInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormInputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
FormInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.3", type: FormInputComponent, selector: "lib-form-input", inputs: { type: "type" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: FormInputComponent,
            multi: true
        }
    ], ngImport: i0, template: "<div class=\"from-group\">\n  <input type={{type}}\n  class=\"form-control\"\n  [ngModel] = \"value\"\n  (ngModelChange)=\"onChange($event)\"\n  (blur)=\"onTouched()\"\n  >\n</div>\n", styles: [""], directives: [{ type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-form-input', providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: FormInputComponent,
                            multi: true
                        }
                    ], template: "<div class=\"from-group\">\n  <input type={{type}}\n  class=\"form-control\"\n  [ngModel] = \"value\"\n  (ngModelChange)=\"onChange($event)\"\n  (blur)=\"onTouched()\"\n  >\n</div>\n", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { type: [{
                type: Input
            }] } });

class FormTextareaComponent {
    constructor() { }
    writeValue(obj) {
        this.value = obj;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    ngOnInit() {
    }
}
FormTextareaComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormTextareaComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
FormTextareaComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.3", type: FormTextareaComponent, selector: "lib-form-textarea", inputs: { row: "row" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: FormTextareaComponent,
            multi: true
        }
    ], ngImport: i0, template: "<textarea\n  class=\"form-control\" rows={{row}}\n  [ngModel] =\"value\"\n  (ngModelChange)=\"onChange($event)\"\n  (blur)=\"onTouched()\"\n  ></textarea>\n", styles: [""], directives: [{ type: i1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormTextareaComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-form-textarea', providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: FormTextareaComponent,
                            multi: true
                        }
                    ], template: "<textarea\n  class=\"form-control\" rows={{row}}\n  [ngModel] =\"value\"\n  (ngModelChange)=\"onChange($event)\"\n  (blur)=\"onTouched()\"\n  ></textarea>\n", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { row: [{
                type: Input
            }] } });

class FormLabelComponent {
    constructor() { }
    ngOnInit() {
    }
}
FormLabelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormLabelComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
FormLabelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.1.3", type: FormLabelComponent, selector: "lib-form-label", inputs: { label: "label", for: "for" }, ngImport: i0, template: "<label for={{for}} class=\"form-label\">{{label}}</label>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormLabelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-form-label', template: "<label for={{for}} class=\"form-label\">{{label}}</label>\n", styles: [""] }]
        }], ctorParameters: function () { return []; }, propDecorators: { label: [{
                type: Input
            }], for: [{
                type: Input
            }] } });

class FormControlsModule {
}
FormControlsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormControlsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
FormControlsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormControlsModule, declarations: [FormControlsComponent,
        FormInputComponent,
        FormTextareaComponent,
        FormLabelComponent], imports: [FormsModule,
        ReactiveFormsModule], exports: [FormControlsComponent,
        FormInputComponent,
        FormLabelComponent,
        FormTextareaComponent] });
FormControlsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormControlsModule, imports: [[
            FormsModule,
            ReactiveFormsModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.1.3", ngImport: i0, type: FormControlsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        FormControlsComponent,
                        FormInputComponent,
                        FormTextareaComponent,
                        FormLabelComponent,
                    ],
                    imports: [
                        FormsModule,
                        ReactiveFormsModule
                    ],
                    exports: [
                        FormControlsComponent,
                        FormInputComponent,
                        FormLabelComponent,
                        FormTextareaComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of form-controls
 */

/**
 * Generated bundle index. Do not edit.
 */

export { FormControlsComponent, FormControlsModule, FormControlsService, FormInputComponent, FormLabelComponent, FormTextareaComponent };
//# sourceMappingURL=bootstrap-reactive-form-controls.mjs.map
